Index: lemon/dijkstra.h
===================================================================
--- lemon/dijkstra.h	(revision 317)
+++ lemon/dijkstra.h	(revision 220)
@@ -31,12 +31,11 @@
 #include <lemon/error.h>
 #include <lemon/maps.h>
-#include <lemon/path.h>
 
 namespace lemon {
 
-  /// \brief Default operation traits for the Dijkstra algorithm class.
+  /// \brief Default OperationTraits for the Dijkstra algorithm class.
   ///
-  /// This operation traits class defines all computational operations and
-  /// constants which are used in the Dijkstra algorithm.
+  /// It defines all computational operations and constants which are
+  /// used in the Dijkstra algorithm.
   template <typename Value>
   struct DijkstraDefaultOperationTraits {
@@ -49,5 +48,5 @@
       return left + right;
     }
-    /// \brief Gives back true only if the first value is less than the second.
+    /// \brief Gives back true only if the first value less than the second.
     static bool less(const Value& left, const Value& right) {
       return left < right;
@@ -55,11 +54,8 @@
   };
 
-  /// \brief Widest path operation traits for the Dijkstra algorithm class.
+  /// \brief Widest path OperationTraits for the Dijkstra algorithm class.
   ///
-  /// This operation traits class defines all computational operations and
-  /// constants which are used in the Dijkstra algorithm for widest path
-  /// computation.
-  ///
-  /// \see DijkstraDefaultOperationTraits
+  /// It defines all computational operations and constants which are
+  /// used in the Dijkstra algorithm for widest path computation.
   template <typename Value>
   struct DijkstraWidestPathOperationTraits {
@@ -72,5 +68,5 @@
       return std::min(left, right);
     }
-    /// \brief Gives back true only if the first value is less than the second.
+    /// \brief Gives back true only if the first value less than the second.
     static bool less(const Value& left, const Value& right) {
       return left < right;
@@ -81,12 +77,11 @@
 
   ///Default traits class of Dijkstra class.
-  ///\tparam GR The type of the digraph.
-  ///\tparam LM The type of the length map.
+  ///\tparam GR Digraph type.
+  ///\tparam LM Type of length map.
   template<class GR, class LM>
   struct DijkstraDefaultTraits
   {
-    ///The type of the digraph the algorithm runs on.
+    ///The digraph type the algorithm runs on.
     typedef GR Digraph;
-
     ///The type of the map that stores the arc lengths.
 
@@ -94,93 +89,94 @@
     ///It must meet the \ref concepts::ReadMap "ReadMap" concept.
     typedef LM LengthMap;
-    ///The type of the length of the arcs.
+    //The type of the length of the arcs.
     typedef typename LM::Value Value;
-
     /// Operation traits for Dijkstra algorithm.
 
-    /// This class defines the operations that are used in the algorithm.
+    /// It defines the used operation by the algorithm.
     /// \see DijkstraDefaultOperationTraits
     typedef DijkstraDefaultOperationTraits<Value> OperationTraits;
-
-    /// The cross reference type used by the heap.
-
-    /// The cross reference type used by the heap.
+    /// The cross reference type used by heap.
+
+
+    /// The cross reference type used by heap.
     /// Usually it is \c Digraph::NodeMap<int>.
     typedef typename Digraph::template NodeMap<int> HeapCrossRef;
-    ///Instantiates a \ref HeapCrossRef.
-
-    ///This function instantiates a \ref HeapCrossRef.
-    /// \param g is the digraph, to which we would like to define the
-    /// \ref HeapCrossRef.
-    static HeapCrossRef *createHeapCrossRef(const Digraph &g)
-    {
-      return new HeapCrossRef(g);
-    }
-
-    ///The heap type used by the Dijkstra algorithm.
-
-    ///The heap type used by the Dijkstra algorithm.
+    ///Instantiates a HeapCrossRef.
+
+    ///This function instantiates a \c HeapCrossRef.
+    /// \param G is the digraph, to which we would like to define the
+    /// HeapCrossRef.
+    static HeapCrossRef *createHeapCrossRef(const GR &G)
+    {
+      return new HeapCrossRef(G);
+    }
+
+    ///The heap type used by Dijkstra algorithm.
+
+    ///The heap type used by Dijkstra algorithm.
     ///
     ///\sa BinHeap
     ///\sa Dijkstra
     typedef BinHeap<typename LM::Value, HeapCrossRef, std::less<Value> > Heap;
-    ///Instantiates a \ref Heap.
-
-    ///This function instantiates a \ref Heap.
-    static Heap *createHeap(HeapCrossRef& r)
-    {
-      return new Heap(r);
-    }
-
-    ///\brief The type of the map that stores the predecessor
+
+    static Heap *createHeap(HeapCrossRef& R)
+    {
+      return new Heap(R);
+    }
+
+    ///\brief The type of the map that stores the last
     ///arcs of the shortest paths.
     ///
-    ///The type of the map that stores the predecessor
+    ///The type of the map that stores the last
     ///arcs of the shortest paths.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
-    typedef typename Digraph::template NodeMap<typename Digraph::Arc> PredMap;
+    ///
+    typedef typename Digraph::template NodeMap<typename GR::Arc> PredMap;
     ///Instantiates a PredMap.
 
-    ///This function instantiates a PredMap.
-    ///\param g is the digraph, to which we would like to define the
-    ///PredMap.
-    static PredMap *createPredMap(const Digraph &g)
-    {
-      return new PredMap(g);
-    }
-
-    ///The type of the map that indicates which nodes are processed.
-
-    ///The type of the map that indicates which nodes are processed.
+    ///This function instantiates a \c PredMap.
+    ///\param G is the digraph, to which we would like to define the PredMap.
+    ///\todo The digraph alone may be insufficient for the initialization
+    static PredMap *createPredMap(const GR &G)
+    {
+      return new PredMap(G);
+    }
+
+    ///The type of the map that stores whether a nodes is processed.
+
+    ///The type of the map that stores whether a nodes is processed.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
     ///By default it is a NullMap.
+    ///\todo If it is set to a real map,
+    ///Dijkstra::processed() should read this.
+    ///\todo named parameter to set this type, function to read and write.
     typedef NullMap<typename Digraph::Node,bool> ProcessedMap;
     ///Instantiates a ProcessedMap.
 
-    ///This function instantiates a ProcessedMap.
+    ///This function instantiates a \c ProcessedMap.
     ///\param g is the digraph, to which
-    ///we would like to define the ProcessedMap
+    ///we would like to define the \c ProcessedMap
 #ifdef DOXYGEN
-    static ProcessedMap *createProcessedMap(const Digraph &g)
+    static ProcessedMap *createProcessedMap(const GR &g)
 #else
-    static ProcessedMap *createProcessedMap(const Digraph &)
+    static ProcessedMap *createProcessedMap(const GR &)
 #endif
     {
       return new ProcessedMap();
     }
-
-    ///The type of the map that stores the distances of the nodes.
-
-    ///The type of the map that stores the distances of the nodes.
+    ///The type of the map that stores the dists of the nodes.
+
+    ///The type of the map that stores the dists of the nodes.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
+    ///
     typedef typename Digraph::template NodeMap<typename LM::Value> DistMap;
     ///Instantiates a DistMap.
 
-    ///This function instantiates a DistMap.
-    ///\param g is the digraph, to which we would like to define
-    ///the DistMap
-    static DistMap *createDistMap(const Digraph &g)
-    {
-      return new DistMap(g);
+    ///This function instantiates a \ref DistMap.
+    ///\param G is the digraph, to which we would like to define
+    ///the \ref DistMap
+    static DistMap *createDistMap(const GR &G)
+    {
+      return new DistMap(G);
     }
   };
@@ -189,32 +185,31 @@
 
   /// \ingroup shortest_path
-  ///This class provides an efficient implementation of the %Dijkstra algorithm.
-  ///
+  ///This class provides an efficient implementation of %Dijkstra algorithm.
   ///The arc lengths are passed to the algorithm using a
   ///\ref concepts::ReadMap "ReadMap",
   ///so it is easy to change it to any kind of length.
+  ///
   ///The type of the length is determined by the
   ///\ref concepts::ReadMap::Value "Value" of the length map.
+  ///
   ///It is also possible to change the underlying priority heap.
   ///
-  ///There is also a \ref dijkstra() "function-type interface" for the
-  ///%Dijkstra algorithm, which is convenient in the simplier cases and
-  ///it can be used easier.
-  ///
-  ///\tparam GR The type of the digraph the algorithm runs on.
-  ///The default value is \ref ListDigraph.
-  ///The value of GR is not used directly by \ref Dijkstra, it is only
-  ///passed to \ref DijkstraDefaultTraits.
-  ///\tparam LM A readable arc map that determines the lengths of the
+  ///\tparam GR The digraph type the algorithm runs on. The default value
+  ///is \ref ListDigraph. The value of GR is not used directly by
+  ///Dijkstra, it is only passed to \ref DijkstraDefaultTraits.
+  ///\tparam LM This read-only ArcMap determines the lengths of the
   ///arcs. It is read once for each arc, so the map may involve in
-  ///relatively time consuming process to compute the arc lengths if
+  ///relatively time consuming process to compute the arc length if
   ///it is necessary. The default map type is \ref
-  ///concepts::Digraph::ArcMap "Digraph::ArcMap<int>".
-  ///The value of LM is not used directly by \ref Dijkstra, it is only
-  ///passed to \ref DijkstraDefaultTraits.
-  ///\tparam TR Traits class to set various data types used by the algorithm.
-  ///The default traits class is \ref DijkstraDefaultTraits
-  ///"DijkstraDefaultTraits<GR,LM>". See \ref DijkstraDefaultTraits
-  ///for the documentation of a Dijkstra traits class.
+  ///concepts::Digraph::ArcMap "Digraph::ArcMap<int>".  The value
+  ///of LM is not used directly by Dijkstra, it is only passed to \ref
+  ///DijkstraDefaultTraits.
+  ///\tparam TR Traits class to set
+  ///various data types used by the algorithm.  The default traits
+  ///class is \ref DijkstraDefaultTraits
+  ///"DijkstraDefaultTraits<GR,LM>".  See \ref
+  ///DijkstraDefaultTraits for the documentation of a Dijkstra traits
+  ///class.
+
 #ifdef DOXYGEN
   template <typename GR, typename LM, typename TR>
@@ -226,7 +221,28 @@
   class Dijkstra {
   public:
-
-    ///The type of the digraph the algorithm runs on.
+    /**
+     * \brief \ref Exception for uninitialized parameters.
+     *
+     * This error represents problems in the initialization
+     * of the parameters of the algorithms.
+     */
+    class UninitializedParameter : public lemon::UninitializedParameter {
+    public:
+      virtual const char* what() const throw() {
+        return "lemon::Dijkstra::UninitializedParameter";
+      }
+    };
+
+    typedef TR Traits;
+    ///The type of the underlying digraph.
     typedef typename TR::Digraph Digraph;
+    ///\e
+    typedef typename Digraph::Node Node;
+    ///\e
+    typedef typename Digraph::NodeIt NodeIt;
+    ///\e
+    typedef typename Digraph::Arc Arc;
+    ///\e
+    typedef typename Digraph::OutArcIt OutArcIt;
 
     ///The type of the length of the arcs.
@@ -234,56 +250,46 @@
     ///The type of the map that stores the arc lengths.
     typedef typename TR::LengthMap LengthMap;
-    ///\brief The type of the map that stores the predecessor arcs of the
-    ///shortest paths.
+    ///\brief The type of the map that stores the last
+    ///arcs of the shortest paths.
     typedef typename TR::PredMap PredMap;
-    ///The type of the map that stores the distances of the nodes.
+    ///The type of the map indicating if a node is processed.
+    typedef typename TR::ProcessedMap ProcessedMap;
+    ///The type of the map that stores the dists of the nodes.
     typedef typename TR::DistMap DistMap;
-    ///The type of the map that indicates which nodes are processed.
-    typedef typename TR::ProcessedMap ProcessedMap;
-    ///The type of the paths.
-    typedef PredMapPath<Digraph, PredMap> Path;
     ///The cross reference type used for the current heap.
     typedef typename TR::HeapCrossRef HeapCrossRef;
-    ///The heap type used by the algorithm.
+    ///The heap type used by the dijkstra algorithm.
     typedef typename TR::Heap Heap;
-    ///The operation traits class.
+    ///The operation traits.
     typedef typename TR::OperationTraits OperationTraits;
-
-    ///The traits class.
-    typedef TR Traits;
-
   private:
-
-    typedef typename Digraph::Node Node;
-    typedef typename Digraph::NodeIt NodeIt;
-    typedef typename Digraph::Arc Arc;
-    typedef typename Digraph::OutArcIt OutArcIt;
-
-    //Pointer to the underlying digraph.
+    /// Pointer to the underlying digraph.
     const Digraph *G;
-    //Pointer to the length map.
+    /// Pointer to the length map
     const LengthMap *length;
-    //Pointer to the map of predecessors arcs.
+    ///Pointer to the map of predecessors arcs.
     PredMap *_pred;
-    //Indicates if _pred is locally allocated (true) or not.
+    ///Indicates if \ref _pred is locally allocated (\c true) or not.
     bool local_pred;
-    //Pointer to the map of distances.
+    ///Pointer to the map of distances.
     DistMap *_dist;
-    //Indicates if _dist is locally allocated (true) or not.
+    ///Indicates if \ref _dist is locally allocated (\c true) or not.
     bool local_dist;
-    //Pointer to the map of processed status of the nodes.
+    ///Pointer to the map of processed status of the nodes.
     ProcessedMap *_processed;
-    //Indicates if _processed is locally allocated (true) or not.
+    ///Indicates if \ref _processed is locally allocated (\c true) or not.
     bool local_processed;
-    //Pointer to the heap cross references.
+    ///Pointer to the heap cross references.
     HeapCrossRef *_heap_cross_ref;
-    //Indicates if _heap_cross_ref is locally allocated (true) or not.
+    ///Indicates if \ref _heap_cross_ref is locally allocated (\c true) or not.
     bool local_heap_cross_ref;
-    //Pointer to the heap.
+    ///Pointer to the heap.
     Heap *_heap;
-    //Indicates if _heap is locally allocated (true) or not.
+    ///Indicates if \ref _heap is locally allocated (\c true) or not.
     bool local_heap;
 
-    //Creates the maps if necessary.
+    ///Creates the maps if necessary.
+
+    ///\todo Better memory allocation (instead of new).
     void create_maps()
     {
@@ -310,5 +316,5 @@
     }
 
-  public:
+  public :
 
     typedef Dijkstra Create;
@@ -319,94 +325,87 @@
 
     template <class T>
-    struct SetPredMapTraits : public Traits {
+    struct DefPredMapTraits : public Traits {
       typedef T PredMap;
       static PredMap *createPredMap(const Digraph &)
       {
-        LEMON_ASSERT(false, "PredMap is not initialized");
-        return 0; // ignore warnings
-      }
-    };
-    ///\brief \ref named-templ-param "Named parameter" for setting
-    ///PredMap type.
-    ///
-    ///\ref named-templ-param "Named parameter" for setting
-    ///PredMap type.
+        throw UninitializedParameter();
+      }
+    };
+    ///\ref named-templ-param "Named parameter" for setting PredMap type
+
+    ///\ref named-templ-param "Named parameter" for setting PredMap type
+    ///
     template <class T>
-    struct SetPredMap
-      : public Dijkstra< Digraph, LengthMap, SetPredMapTraits<T> > {
-      typedef Dijkstra< Digraph, LengthMap, SetPredMapTraits<T> > Create;
+    struct DefPredMap
+      : public Dijkstra< Digraph, LengthMap, DefPredMapTraits<T> > {
+      typedef Dijkstra< Digraph, LengthMap, DefPredMapTraits<T> > Create;
     };
 
     template <class T>
-    struct SetDistMapTraits : public Traits {
+    struct DefDistMapTraits : public Traits {
       typedef T DistMap;
       static DistMap *createDistMap(const Digraph &)
       {
-        LEMON_ASSERT(false, "DistMap is not initialized");
-        return 0; // ignore warnings
-      }
-    };
-    ///\brief \ref named-templ-param "Named parameter" for setting
-    ///DistMap type.
-    ///
-    ///\ref named-templ-param "Named parameter" for setting
-    ///DistMap type.
+        throw UninitializedParameter();
+      }
+    };
+    ///\ref named-templ-param "Named parameter" for setting DistMap type
+
+    ///\ref named-templ-param "Named parameter" for setting DistMap type
+    ///
     template <class T>
-    struct SetDistMap
-      : public Dijkstra< Digraph, LengthMap, SetDistMapTraits<T> > {
-      typedef Dijkstra< Digraph, LengthMap, SetDistMapTraits<T> > Create;
+    struct DefDistMap
+      : public Dijkstra< Digraph, LengthMap, DefDistMapTraits<T> > {
+      typedef Dijkstra< Digraph, LengthMap, DefDistMapTraits<T> > Create;
     };
 
     template <class T>
-    struct SetProcessedMapTraits : public Traits {
+    struct DefProcessedMapTraits : public Traits {
       typedef T ProcessedMap;
-      static ProcessedMap *createProcessedMap(const Digraph &)
+      static ProcessedMap *createProcessedMap(const Digraph &G)
       {
-        LEMON_ASSERT(false, "ProcessedMap is not initialized");
-        return 0; // ignore warnings
-      }
-    };
-    ///\brief \ref named-templ-param "Named parameter" for setting
-    ///ProcessedMap type.
-    ///
-    ///\ref named-templ-param "Named parameter" for setting
-    ///ProcessedMap type.
+        throw UninitializedParameter();
+      }
+    };
+    ///\ref named-templ-param "Named parameter" for setting ProcessedMap type
+
+    ///\ref named-templ-param "Named parameter" for setting ProcessedMap type
+    ///
     template <class T>
-    struct SetProcessedMap
-      : public Dijkstra< Digraph, LengthMap, SetProcessedMapTraits<T> > {
-      typedef Dijkstra< Digraph, LengthMap, SetProcessedMapTraits<T> > Create;
-    };
-
-    struct SetStandardProcessedMapTraits : public Traits {
+    struct DefProcessedMap
+      : public Dijkstra< Digraph, LengthMap, DefProcessedMapTraits<T> > {
+      typedef Dijkstra< Digraph, LengthMap, DefProcessedMapTraits<T> > Create;
+    };
+
+    struct DefDigraphProcessedMapTraits : public Traits {
       typedef typename Digraph::template NodeMap<bool> ProcessedMap;
-      static ProcessedMap *createProcessedMap(const Digraph &g)
+      static ProcessedMap *createProcessedMap(const Digraph &G)
       {
-        return new ProcessedMap(g);
-      }
-    };
-    ///\brief \ref named-templ-param "Named parameter" for setting
-    ///ProcessedMap type to be <tt>Digraph::NodeMap<bool></tt>.
-    ///
-    ///\ref named-templ-param "Named parameter" for setting
-    ///ProcessedMap type to be <tt>Digraph::NodeMap<bool></tt>.
-    ///If you don't set it explicitly, it will be automatically allocated.
-    struct SetStandardProcessedMap
-      : public Dijkstra< Digraph, LengthMap, SetStandardProcessedMapTraits > {
-      typedef Dijkstra< Digraph, LengthMap, SetStandardProcessedMapTraits >
+        return new ProcessedMap(G);
+      }
+    };
+    ///\brief \ref named-templ-param "Named parameter"
+    ///for setting the ProcessedMap type to be Digraph::NodeMap<bool>.
+    ///
+    ///\ref named-templ-param "Named parameter"
+    ///for setting the ProcessedMap type to be Digraph::NodeMap<bool>.
+    ///If you don't set it explicitely, it will be automatically allocated.
+    template <class T>
+    struct DefProcessedMapToBeDefaultMap
+      : public Dijkstra< Digraph, LengthMap, DefDigraphProcessedMapTraits> {
+      typedef Dijkstra< Digraph, LengthMap, DefDigraphProcessedMapTraits>
       Create;
     };
 
     template <class H, class CR>
-    struct SetHeapTraits : public Traits {
+    struct DefHeapTraits : public Traits {
       typedef CR HeapCrossRef;
       typedef H Heap;
       static HeapCrossRef *createHeapCrossRef(const Digraph &) {
-        LEMON_ASSERT(false, "HeapCrossRef is not initialized");
-        return 0; // ignore warnings
+        throw UninitializedParameter();
       }
       static Heap *createHeap(HeapCrossRef &)
       {
-        LEMON_ASSERT(false, "Heap is not initialized");
-        return 0; // ignore warnings
+        throw UninitializedParameter();
       }
     };
@@ -415,13 +414,14 @@
     ///
     ///\ref named-templ-param "Named parameter" for setting heap and cross
-    ///reference type.
+    ///reference type
+    ///
     template <class H, class CR = typename Digraph::template NodeMap<int> >
-    struct SetHeap
-      : public Dijkstra< Digraph, LengthMap, SetHeapTraits<H, CR> > {
-      typedef Dijkstra< Digraph, LengthMap, SetHeapTraits<H, CR> > Create;
+    struct DefHeap
+      : public Dijkstra< Digraph, LengthMap, DefHeapTraits<H, CR> > {
+      typedef Dijkstra< Digraph, LengthMap, DefHeapTraits<H, CR> > Create;
     };
 
     template <class H, class CR>
-    struct SetStandardHeapTraits : public Traits {
+    struct DefStandardHeapTraits : public Traits {
       typedef CR HeapCrossRef;
       typedef H Heap;
@@ -442,24 +442,24 @@
     ///parameter and the heap's constructor waits for the cross reference.
     template <class H, class CR = typename Digraph::template NodeMap<int> >
-    struct SetStandardHeap
-      : public Dijkstra< Digraph, LengthMap, SetStandardHeapTraits<H, CR> > {
-      typedef Dijkstra< Digraph, LengthMap, SetStandardHeapTraits<H, CR> >
+    struct DefStandardHeap
+      : public Dijkstra< Digraph, LengthMap, DefStandardHeapTraits<H, CR> > {
+      typedef Dijkstra< Digraph, LengthMap, DefStandardHeapTraits<H, CR> >
       Create;
     };
 
     template <class T>
-    struct SetOperationTraitsTraits : public Traits {
+    struct DefOperationTraitsTraits : public Traits {
       typedef T OperationTraits;
     };
 
     /// \brief \ref named-templ-param "Named parameter" for setting
-    ///\c OperationTraits type
-    ///
-    ///\ref named-templ-param "Named parameter" for setting
-    ///\ref OperationTraits type.
+    /// OperationTraits type
+    ///
+    /// \ref named-templ-param "Named parameter" for setting OperationTraits
+    /// type
     template <class T>
-    struct SetOperationTraits
-      : public Dijkstra<Digraph, LengthMap, SetOperationTraitsTraits<T> > {
-      typedef Dijkstra<Digraph, LengthMap, SetOperationTraitsTraits<T> >
+    struct DefOperationTraits
+      : public Dijkstra<Digraph, LengthMap, DefOperationTraitsTraits<T> > {
+      typedef Dijkstra<Digraph, LengthMap, DefOperationTraitsTraits<T> >
       Create;
     };
@@ -467,4 +467,5 @@
     ///@}
 
+
   protected:
 
@@ -475,9 +476,8 @@
     ///Constructor.
 
-    ///Constructor.
-    ///\param _g The digraph the algorithm runs on.
-    ///\param _length The length map used by the algorithm.
-    Dijkstra(const Digraph& _g, const LengthMap& _length) :
-      G(&_g), length(&_length),
+    ///\param _G the digraph the algorithm will run on.
+    ///\param _length the length map used by the algorithm.
+    Dijkstra(const Digraph& _G, const LengthMap& _length) :
+      G(&_G), length(&_length),
       _pred(NULL), local_pred(false),
       _dist(NULL), local_dist(false),
@@ -507,9 +507,9 @@
     }
 
-    ///Sets the map that stores the predecessor arcs.
-
-    ///Sets the map that stores the predecessor arcs.
+    ///Sets the map storing the predecessor arcs.
+
+    ///Sets the map storing the predecessor arcs.
     ///If you don't use this function before calling \ref run(),
-    ///it will allocate one. The destructor deallocates this
+    ///it will allocate one. The destuctor deallocates this
     ///automatically allocated map, of course.
     ///\return <tt> (*this) </tt>
@@ -524,27 +524,9 @@
     }
 
-    ///Sets the map that indicates which nodes are processed.
-
-    ///Sets the map that indicates which nodes are processed.
+    ///Sets the map storing the distances calculated by the algorithm.
+
+    ///Sets the map storing the distances calculated by the algorithm.
     ///If you don't use this function before calling \ref run(),
-    ///it will allocate one. The destructor deallocates this
-    ///automatically allocated map, of course.
-    ///\return <tt> (*this) </tt>
-    Dijkstra &processedMap(ProcessedMap &m)
-    {
-      if(local_processed) {
-        delete _processed;
-        local_processed=false;
-      }
-      _processed = &m;
-      return *this;
-    }
-
-    ///Sets the map that stores the distances of the nodes.
-
-    ///Sets the map that stores the distances of the nodes calculated by the
-    ///algorithm.
-    ///If you don't use this function before calling \ref run(),
-    ///it will allocate one. The destructor deallocates this
+    ///it will allocate one. The destuctor deallocates this
     ///automatically allocated map, of course.
     ///\return <tt> (*this) </tt>
@@ -563,5 +545,5 @@
     ///Sets the heap and the cross reference used by algorithm.
     ///If you don't use this function before calling \ref run(),
-    ///it will allocate one. The destructor deallocates this
+    ///it will allocate one. The destuctor deallocates this
     ///automatically allocated heap and cross reference, of course.
     ///\return <tt> (*this) </tt>
@@ -582,5 +564,4 @@
 
   private:
-
     void finalizeNodeData(Node v,Value dst)
     {
@@ -591,13 +572,15 @@
   public:
 
+    typedef PredMapPath<Digraph, PredMap> Path;
+
     ///\name Execution control
-    ///The simplest way to execute the algorithm is to use one of the
-    ///member functions called \ref lemon::Dijkstra::run() "run()".
+    ///The simplest way to execute the algorithm is to use
+    ///one of the member functions called \c run(...).
     ///\n
-    ///If you need more control on the execution, first you must call
-    ///\ref lemon::Dijkstra::init() "init()", then you can add several
-    ///source nodes with \ref lemon::Dijkstra::addSource() "addSource()".
-    ///Finally \ref lemon::Dijkstra::start() "start()" will perform the
-    ///actual path computation.
+    ///If you need more control on the execution,
+    ///first you must call \ref init(), then you can add several source nodes
+    ///with \ref addSource().
+    ///Finally \ref start() will perform the actual path
+    ///computation.
 
     ///@{
@@ -621,7 +604,8 @@
 
     ///Adds a new source node to the priority heap.
+    ///
     ///The optional second parameter is the initial distance of the node.
     ///
-    ///The function checks if the node has already been added to the heap and
+    ///It checks if the node has already been added to the heap and
     ///it is pushed to the heap only if either it was not in the heap
     ///or the shortest path found till then is shorter than \c dst.
@@ -642,5 +626,5 @@
     ///\return The processed node.
     ///
-    ///\warning The priority heap must not be empty.
+    ///\warning The priority heap must not be empty!
     Node processNextNode()
     {
@@ -673,9 +657,11 @@
     }
 
-    ///The next node to be processed.
-
-    ///Returns the next node to be processed or \c INVALID if the
-    ///priority heap is empty.
-    Node nextNode() const
+    ///Next node to be processed.
+
+    ///Next node to be processed.
+    ///
+    ///\return The next node to be processed or INVALID if the priority heap
+    /// is empty.
+    Node nextNode()
     {
       return !_heap->empty()?_heap->top():INVALID;
@@ -683,15 +669,14 @@
 
     ///\brief Returns \c false if there are nodes
-    ///to be processed.
+    ///to be processed in the priority heap
     ///
     ///Returns \c false if there are nodes
-    ///to be processed in the priority heap.
-    bool emptyQueue() const { return _heap->empty(); }
-
+    ///to be processed in the priority heap
+    bool emptyQueue() { return _heap->empty(); }
     ///Returns the number of the nodes to be processed in the priority heap
 
-    ///Returns the number of the nodes to be processed in the priority heap.
-    ///
-    int queueSize() const { return _heap->size(); }
+    ///Returns the number of the nodes to be processed in the priority heap
+    ///
+    int queueSize() { return _heap->size(); }
 
     ///Executes the algorithm.
@@ -699,45 +684,37 @@
     ///Executes the algorithm.
     ///
+    ///\pre init() must be called and at least one node should be added
+    ///with addSource() before using this function.
+    ///
     ///This method runs the %Dijkstra algorithm from the root node(s)
-    ///in order to compute the shortest path to each node.
-    ///
-    ///The algorithm computes
-    ///- the shortest path tree (forest),
-    ///- the distance of each node from the root(s).
-    ///
-    ///\pre init() must be called and at least one root node should be
-    ///added with addSource() before using this function.
-    ///
-    ///\note <tt>d.start()</tt> is just a shortcut of the following code.
-    ///\code
-    ///  while ( !d.emptyQueue() ) {
-    ///    d.processNextNode();
-    ///  }
-    ///\endcode
+    ///in order to
+    ///compute the
+    ///shortest path to each node. The algorithm computes
+    ///- The shortest path tree.
+    ///- The distance of each node from the root(s).
+    ///
     void start()
     {
-      while ( !emptyQueue() ) processNextNode();
-    }
-
-    ///Executes the algorithm until the given target node is processed.
-
-    ///Executes the algorithm until the given target node is processed.
+      while ( !_heap->empty() ) processNextNode();
+    }
+
+    ///Executes the algorithm until \c dest is reached.
+
+    ///Executes the algorithm until \c dest is reached.
+    ///
+    ///\pre init() must be called and at least one node should be added
+    ///with addSource() before using this function.
     ///
     ///This method runs the %Dijkstra algorithm from the root node(s)
-    ///in order to compute the shortest path to \c t.
-    ///
-    ///The algorithm computes
-    ///- the shortest path to \c t,
-    ///- the distance of \c t from the root(s).
-    ///
-    ///\pre init() must be called and at least one root node should be
-    ///added with addSource() before using this function.
-    void start(Node t)
-    {
-      while ( !_heap->empty() && _heap->top()!=t ) processNextNode();
-      if ( !_heap->empty() ) {
-        finalizeNodeData(_heap->top(),_heap->prio());
-        _heap->pop();
-      }
+    ///in order to
+    ///compute the
+    ///shortest path to \c dest. The algorithm computes
+    ///- The shortest path to \c  dest.
+    ///- The distance of \c dest from the root(s).
+    ///
+    void start(Node dest)
+    {
+      while ( !_heap->empty() && _heap->top()!=dest ) processNextNode();
+      if ( !_heap->empty() ) finalizeNodeData(_heap->top(),_heap->prio());
     }
 
@@ -746,16 +723,12 @@
     ///Executes the algorithm until a condition is met.
     ///
-    ///This method runs the %Dijkstra algorithm from the root node(s) in
-    ///order to compute the shortest path to a node \c v with
-    /// <tt>nm[v]</tt> true, if such a node can be found.
-    ///
-    ///\param nm A \c bool (or convertible) node map. The algorithm
+    ///\pre init() must be called and at least one node should be added
+    ///with addSource() before using this function.
+    ///
+    ///\param nm must be a bool (or convertible) node map. The algorithm
     ///will stop when it reaches a node \c v with <tt>nm[v]</tt> true.
     ///
     ///\return The reached node \c v with <tt>nm[v]</tt> true or
     ///\c INVALID if no such node was found.
-    ///
-    ///\pre init() must be called and at least one root node should be
-    ///added with addSource() before using this function.
     template<class NodeBoolMap>
     Node start(const NodeBoolMap &nm)
